//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1  DeepSkyBlue
#property indicator_color2  PaleVioletRed
#property indicator_color3  DarkSlateGray
#property indicator_color4  Red
#property indicator_color5  Yellow
#property indicator_color6  DodgerBlue
#property indicator_color7  Red
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2

//
//
//
//
//

extern int    TrixPeriod       = 14;
extern int    TrixPrice        = PRICE_CLOSE;
extern int    SignalPeriod     = 10;
extern int    SignalMode       = MODE_SMMA;
extern bool   Signals          = true;
extern int    HistoMultiplier  = 2;
extern string note             = "turn on Alert = true; turn off = false";
extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsNotify     = true;
extern bool   alertsEmail      = true;
extern string soundFile        = "alert2.wav"; 
extern bool   ShowArrows       = true;
extern string arrowsIdentifier = "trix Arrows1";
extern double arrowsUpperGap   = 1.0;
extern double arrowsLowerGap   = 1.0;
extern color  arrowsUpColor    = LimeGreen;
extern color  arrowsDnColor    = Red;
extern int    arrowsUpCode     = 241;
extern int    arrowsDnCode     = 242;

//
//
//
//
//

double upH[];
double dnH[];
double diff[];
double Trix[];
double Sign[];
double upA[];
double dnA[];
double trend[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,upH); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,dnH); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,diff);
   SetIndexBuffer(3,Trix);
   SetIndexBuffer(4,Sign);
   SetIndexBuffer(5,upA);  SetIndexBuffer(5,upA); SetIndexStyle(5,DRAW_ARROW); SetIndexArrow(5,233);
   SetIndexBuffer(6,dnA);  SetIndexBuffer(6,dnA); SetIndexStyle(6,DRAW_ARROW); SetIndexArrow(6,234); 
   SetIndexBuffer(7,trend);
   IndicatorShortName("Trix ("+TrixPeriod+","+SignalPeriod+")");
   return(0);
}

int deinit() 
{  
   deleteArrows(); 
return(0); 
}

//
//
//
//
//

double workTrix[][3];
int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(workTrix,0)!=Bars) ArrayResize(workTrix,Bars);

   //
   //
   //
   //
   //

   double alpha = 2.0/(1.0+TrixPeriod);
      for(i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         double price = MathLog(iMA(NULL,0,1,0,MODE_SMA,TrixPrice,i));
            workTrix[r][0] =  workTrix[r-1][0]+alpha*(price         -workTrix[r-1][0]);
            workTrix[r][1] =  workTrix[r-1][1]+alpha*(workTrix[r][0]-workTrix[r-1][1]);
            workTrix[r][2] =  workTrix[r-1][2]+alpha*(workTrix[r][1]-workTrix[r-1][2]);
         
            if (workTrix[r-1][2]!=0)
                 Trix[i] = (workTrix[r][2]-workTrix[r-1][2])/workTrix[r-1][2];
            else Trix[i] = 0.00;
      }
      
      for (i=limit; i>=0; i--) 
      { 
         Sign[i] = iMAOnArray(Trix,0,SignalPeriod,0,SignalMode,i);
         diff[i] = (Trix[i] - Sign[i]) * HistoMultiplier;;
         upH[i]  = EMPTY_VALUE;
         dnH[i]  = EMPTY_VALUE;
         if (diff[i]>0) trend[i] = 1;
         if (diff[i]<0) trend[i] =-1;
         if (trend[i] == 1) upH[i] = diff[i];   
         if (trend[i] ==-1) dnH[i] = diff[i];  
         
         //
         //
         //
         //
         //
         
         if (Signals)
         {
           upA[i]  = EMPTY_VALUE;
           dnA[i]  = EMPTY_VALUE;
           if (trend[i] != trend[i+1])
           {
             if (trend[i] == 1) upA[i] = Sign[i] - 0.0001;
             if (trend[i] ==-1) dnA[i] = Sign[i] + 0.0001; 
           }
         } 
         
         //
         //
         //
         //
         //
   
         if (ShowArrows)
         {
           deleteArrow(Time[i]);
           if (trend[i] != trend[i+1])
           {
              if (trend[i] == 1)  drawArrow(i,arrowsUpColor,arrowsUpCode,false);
              if (trend[i] ==-1)  drawArrow(i,arrowsDnColor,arrowsDnCode, true);
           }
         }
   }
   
   //
   //
   //
   //
   //
  
   if (alertsOn)
   {
     if (alertsOnCurrent)
          int whichBar = 0;
     else     whichBar = 1;
     if (trend[whichBar] != trend[whichBar+1])
     if (trend[whichBar] == 1)
           doAlert("uptrend");
     else  doAlert("downtrend");       
   }
return(0);
}

//
//
//
//
//+------------------------------------------------------------------+

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Trix ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," Trix " +" "+message));
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " Trix "),message);
          if (alertsSound)   PlaySound(soundFile);
      }
}

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}
         
         
   